<?php
/**
* @version $Id: $
* @package osm-things
* @copyright Copyright (C) 2008 Sebastian Klemm.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

// self-made function for formatted error output and script break
function stop($message) {
	out($message, 'OUT_ERROR');
	include("./foot.inc");
	exit();
}
// self-made function for formatted output via 'echo()'
function out($message, $type) {
	// definitions of constants for 'type'
	$OUT_ERROR = 0;
	$OUT_DEBUG = 1;
	$OUT_INFO = 2;
	$OUT_WARNING = 3;

    // format strings for different messages
    $outstr[0] = array('<h3 style="color:red">', "</h3>\n<a href=\"Javascript:history.back()\">zur&uuml;ck</a>");
    $outstr[1] = array("\n<span style=\"background-color:#CCCCCC\">", "</span><br>\n");
    $outstr[2] = array("<br>\n<b><i>", "</i></b><br>\n");
    $outstr[3] = array("\n<b style=\"color:red\">", "</b><br>\n");

	if(!is_int($type)) $type = $$type;
	echo $outstr[$type][0] . $message . $outstr[$type][1];
}


// self-made function like 'scandir()' from PHP5
function scan_dir($dir, $sorting_order, $type) {
	$filelist = scan_dir_f($dir, $sorting_order, $type, 0);
	return $filelist;
}

// self-made extended scandir function with filetype filter
function scan_dir_f($dir, $sorting_order, $type, $filter) {
	// definitions of constants for 'type'
	$FILETYPE_ALL = 0;
	$FILETYPE_DIR = 1;
	$FILETYPE_FILE = 2;

	if(!is_int($type)) $type = $$type;
	clearstatcache();
	$dirhandle  = opendir($dir);
	while (false !== ($file = readdir($dirhandle))) {
    	if($file != "." && $file != "..") {
	   		switch($type) {
	   			case 0:
	    			$files[] = $file;
		    		break;
	   			case 1:
	    			if(is_dir($dir.$file)) $files[] = $file;
		    		break;
	   			case 2:
	    			if(is_file($dir.$file)) {
                        $ext = substr($file, strrpos($file, '.')+1);
                        if($filter === 0 || $ext === $filter)
                        	$files[] = $file;
                    }
		    		break;
	    	}
	   	}
	}
	closedir($dirhandle);
	if(isset($files)) {	# prevents php warning
        if($sorting_order == 1) rsort($files);
        else                    sort($files);
    }
	return $files;
}


// Simple function to replicate PHP5 'microtime(true)' behaviour
function microtime_float() {
    list($usec, $sec) = explode(" ", microtime());
    return ((float)$usec + (float)$sec);
}


// converts a date or timestamp string to UNIX timestamp
function str_to_time($str) {
	if(strlen($str) == 10 || strlen($str) == 19) {	# "2000-12-31[ 23:59:59]" date[time] or timestamp (MySQL 4.1) format
		$date = mktime(substr($str,11,2),substr($str,14,2),substr($str,17,2), substr($str,5,2),substr($str,8,2),substr($str,0,4));
	}
	if(strlen($str) == 14) {	# "20001231235959" timestamp format
		$date = mktime(substr($str,8,2),substr($str,10,2),substr($str,12,2), substr($str,4,2),substr($str,6,2),substr($str,0,4));
	}
	return $date;
}


// data base handling, especially queries
function db_connect($db) {
    $link = db_connect_h("localhost", $db, "php-system", "php-system");
    return $link;
}
function db_connect_u($db, $user, $pw) {
	$link = db_connect_h("localhost", $db, $user, $pw);
    return $link;
}
function db_connect_h($host, $db, $user, $pw) {
    $link = mysql_connect($host, $user, $pw)
        or die($outstr[0][0]."Keine Verbindung zur Datenbank mglich!".$outstr[0][1]);
    mysql_select_db($db)
        or die($outstr[0][0]."Die Datenbank existiert nicht!".$outstr[0][1]);
    return $link;
}
function db_query($query) {
    $result = mysql_query($query) or die ("Ungltige Abfrage: " . mysql_error());
    return $result;
}
function db_close($result, $link) {
    if($result !== TRUE) mysql_free_result($result);
    mysql_close($link);
}


function check_SQL_NULL(&$item) {
	if($item)	$item = "'".$item."'";
	else		$item = 'NULL';
}

function get_lang($lang) {
	// checks for language file
	if(!file_exists( _PATH.'languages/'.$lang.'.php' ) ||
		filesize( _PATH.'languages/'.$lang.'.php' ) < 100) {
		$lang = 'english';
	}
	return $lang;
}
?>
